"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.unmarshall = exports.marshall = exports.Marshallers = exports.marshaller = void 0;
var M = __importStar(require("@aws-sdk/util-dynamodb"));
exports.marshaller = {
    marshallValue: function (value) {
        return M.convertToAttr(value, {
            convertEmptyValues: true,
            convertClassInstanceToMap: true,
            removeUndefinedValues: true,
        });
    },
    unmarshallValue: function (value) {
        return M.convertToNative(value, { wrapNumbers: false });
    },
    marshallItem: function (value) {
        return M.marshall(value, {
            convertEmptyValues: true,
            convertClassInstanceToMap: true,
            removeUndefinedValues: true,
        });
    },
    unmarshallItem: function (value) {
        return M.unmarshall(value, { wrapNumbers: false });
    },
};
var buildMarshaller = function (optional) {
    if (optional === void 0) { optional = false; }
    return ({
        to: function (t) { return exports.marshaller.marshallValue(t); },
        from: function (av) {
            if (!av) {
                if (!optional) {
                    // eslint-disable-next-line functional/no-throw-statement
                    throw new Error('Cannot unmarshall from null attribute to required field');
                }
                else {
                    return undefined;
                }
            }
            var val = exports.marshaller.unmarshallValue(av);
            return val;
        },
        optional: function () { return buildMarshaller(true); },
    });
};
/* istanbul ignore next */
exports.Marshallers = {
    string: buildMarshaller(),
    number: buildMarshaller(),
    binary: buildMarshaller(),
    bool: buildMarshaller(),
    stringSet: buildMarshaller(),
    numberSet: buildMarshaller(),
    map: function (schema) {
        return ({
            from: function (av) {
                return exports.unmarshall(schema, av);
            },
            to: function (t) { return exports.marshall(t); },
            optional: function () { return buildMarshaller(true); },
        });
    },
    arrayBuffer: buildMarshaller(),
    arrayBufferView: buildMarshaller(),
};
var marshall = function (t) {
    return exports.marshaller.marshallValue(t);
};
exports.marshall = marshall;
var unmarshall = function (schema, item) {
    var keys = Object.keys(schema);
    return keys.reduce(function (p, n) {
        var _a;
        return Object.assign({}, p, (_a = {},
            _a[n] = schema[n].from(item[n]),
            _a));
    }, {});
};
exports.unmarshall = unmarshall;
