"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.tableBuilder = void 0;
var table_1 = require("./table");
var _tableBuilder = function (tableDefinition) {
    var withKey = {
        withKey: function (pk, sk) {
            return _tableBuilder(__assign(__assign({}, tableDefinition), { partitionKey: pk, sortKey: sk }));
        },
    };
    var build = {
        build: function (cfg) { return table_1.Table(tableDefinition, cfg); },
    };
    var withIndex = {
        withGlobalIndex: function (name, pk, sk) {
            var _a;
            return _tableBuilder(__assign(__assign({}, tableDefinition), { indexes: __assign(__assign({}, tableDefinition.indexes), (_a = {}, _a[name] = { name: name, partitionKey: pk, sortKey: sk }, _a)) }));
        },
        withLocalIndex: function (name, sk) {
            var _a;
            return _tableBuilder(__assign(__assign({}, tableDefinition), { indexes: __assign(__assign({}, tableDefinition.indexes), (_a = {},
                    _a[name] = {
                        name: name,
                        partitionKey: tableDefinition.partitionKey,
                        sortKey: sk,
                    },
                    _a)) }));
        },
    };
    return __assign(__assign(__assign(__assign({}, withKey), build), withIndex), { _debug: function () { return tableDefinition; } });
};
var tableBuilder = function (name) {
    return _tableBuilder({
        name: name,
        partitionKey: undefined,
        indexes: {},
    });
};
exports.tableBuilder = tableBuilder;
