"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Table = void 0;
var client_dynamodb_1 = require("@aws-sdk/client-dynamodb");
var dynamodb_expressions_1 = require("@awslabs-community-fork/dynamodb-expressions");
var conditions_1 = require("./conditions");
var marshalling_1 = require("./marshalling");
var extractKey = function (obj, hk, rk) {
    var _a, _b;
    return Object.assign({}, (_a = {}, _a[hk] = obj[hk], _a), rk && (_b = {}, _b[rk] = obj[rk], _b));
};
var serializeSetAction = function (r, path, ue) {
    if (path === void 0) { path = []; }
    if (ue === void 0) { ue = new dynamodb_expressions_1.UpdateExpression(); }
    return Object.keys(r).reduce(function (p, n) {
        var toSet = r[n];
        if (!Array.isArray(toSet) && typeof toSet === 'object') {
            serializeSetAction(
            // eslint-disable-next-line @typescript-eslint/no-explicit-any
            toSet, __spread(path, [{ type: 'AttributeName', name: n }]), ue);
        }
        else {
            toSet
                ? p.set(new dynamodb_expressions_1.AttributePath(__spread(path, [
                    { type: 'AttributeName', name: n },
                ])), toSet)
                : p.remove(new dynamodb_expressions_1.AttributePath(__spread(path, [
                    { type: 'AttributeName', name: n },
                ])));
        }
        return p;
    }, ue);
};
/* eslint-disable  @typescript-eslint/no-explicit-any */
var query = function (dynamo, logger, table, hk, rk, marshaller, indexName) { return function (hkv, opts) {
    var _a, _b, _c;
    var _d;
    var attributes = new dynamodb_expressions_1.ExpressionAttributes();
    var keyExpression = attributes.addName(hk) + " = " + attributes.addValue(hkv) + ((opts === null || opts === void 0 ? void 0 : opts.sortKeyExpression) ? " and " + conditions_1.serializeConditionExpression((_a = {},
        _a[rk] = opts.sortKeyExpression,
        _a), attributes)
        : '');
    var lastKey = (_d = opts === null || opts === void 0 ? void 0 : opts.startKey) !== null && _d !== void 0 ? _d : ((opts === null || opts === void 0 ? void 0 : opts.fromSortKey) &&
        rk &&
        Object.assign({}, (_b = {}, _b[hk] = hkv, _b), (_c = {}, _c[rk] = opts.fromSortKey, _c)));
    var filterExpression = (opts === null || opts === void 0 ? void 0 : opts.filterExpression) ? conditions_1.serializeConditionExpression(opts.filterExpression, attributes)
        : undefined;
    return dynamo
        .query({
        TableName: table,
        Limit: opts === null || opts === void 0 ? void 0 : opts.pageSize,
        IndexName: indexName,
        KeyConditionExpression: keyExpression,
        ExpressionAttributeNames: attributes.names,
        ExpressionAttributeValues: attributes.values,
        ExclusiveStartKey: lastKey && marshaller.marshallItem(lastKey),
        ScanIndexForward: !(opts && opts.descending),
        FilterExpression: filterExpression,
    })
        .then(function (r) {
        var _a;
        var nextStartKey = r.LastEvaluatedKey &&
            rk &&
            marshaller.unmarshallItem(r.LastEvaluatedKey);
        return {
            records: (_a = r.Items) === null || _a === void 0 ? void 0 : _a.map(marshaller.unmarshallItem.bind(marshaller)),
            lastSortKey: nextStartKey === null || nextStartKey === void 0 ? void 0 : nextStartKey[rk],
            nextStartKey: nextStartKey,
        };
    })
        .catch(function (e) {
        logger.error(e);
        return Promise.reject(e);
    });
}; };
var scan = function (dynamo, logger, table, hk, rk, marshaller, indexName) { return function (opts) {
    var _a, _b;
    var _c;
    var attributes = new dynamodb_expressions_1.ExpressionAttributes();
    var lastKey = (_c = opts === null || opts === void 0 ? void 0 : opts.startKey) !== null && _c !== void 0 ? _c : ((opts === null || opts === void 0 ? void 0 : opts.fromSortKey) &&
        rk &&
        Object.assign({}, (_a = {}, _a[hk] = opts.fromHashKey, _a), (_b = {}, _b[rk] = opts.fromSortKey, _b)));
    var filterExpression = (opts === null || opts === void 0 ? void 0 : opts.filterExpression) ? conditions_1.serializeConditionExpression(opts.filterExpression, attributes)
        : undefined;
    return dynamo
        .scan({
        TableName: table,
        Limit: opts === null || opts === void 0 ? void 0 : opts.pageSize,
        IndexName: indexName,
        ExpressionAttributeNames: Object.keys(attributes.names).length > 0 ? attributes.names : undefined,
        ExpressionAttributeValues: Object.keys(attributes.values).length > 0
            ? attributes.values
            : undefined,
        ExclusiveStartKey: lastKey && marshaller.marshallItem(lastKey),
        FilterExpression: filterExpression,
    })
        .then(function (r) {
        var _a;
        var nextStartKey = r.LastEvaluatedKey &&
            rk &&
            marshaller.unmarshallItem(r.LastEvaluatedKey);
        return {
            records: (_a = r.Items) === null || _a === void 0 ? void 0 : _a.map(marshaller.unmarshallItem.bind(marshaller)),
            lastHashKey: r.LastEvaluatedKey &&
                marshaller.unmarshallItem(r.LastEvaluatedKey)[hk],
            lastSortKey: nextStartKey === null || nextStartKey === void 0 ? void 0 : nextStartKey[rk],
            nextStartKey: nextStartKey,
        };
    })
        .catch(function (e) {
        logger.error(e);
        return Promise.reject(e);
    });
}; };
/**
 *
 * @param table The name of the DynamoDB table
 * @param config The dynamoDb and marshalling { @link Config }
 * @param client An optional implementation of the { @link DynamoDb } client
 */
// prettier-ignoreclie
var Table = function (tableDefintion, config) {
    var logger = config.logger || console;
    var dynamo = (config === null || config === void 0 ? void 0 : config.client) || new client_dynamodb_1.DynamoDB(config);
    var tableName = tableDefintion.name, hashKey = tableDefintion.partitionKey, sortKey = tableDefintion.sortKey, indexes = tableDefintion.indexes;
    var retval = {
        get: function (hkv, opts) {
            var keys = ((opts === null || opts === void 0 ? void 0 : opts.keys) || []);
            var keysSupplied = keys.length > 0;
            var projectionExpressionAttributes = new dynamodb_expressions_1.ExpressionAttributes();
            var projectionExpression = keys
                .map(function (k) {
                var exp = projectionExpressionAttributes.addName(new dynamodb_expressions_1.AttributePath(k));
                return exp;
            })
                .join(', ');
            var req = {
                TableName: tableDefintion.name,
                Key: marshalling_1.marshaller.marshallItem(extractKey(hkv, tableDefintion.partitionKey, sortKey)),
                ConsistentRead: opts === null || opts === void 0 ? void 0 : opts.consistentRead,
                ProjectionExpression: keysSupplied ? projectionExpression : undefined,
                ExpressionAttributeNames: keysSupplied
                    ? projectionExpressionAttributes.names
                    : undefined,
            };
            return dynamo
                .getItem(req)
                .then(function (r) {
                return r.Item
                    ? (opts === null || opts === void 0 ? void 0 : opts.marshaller) ? marshalling_1.unmarshall(opts === null || opts === void 0 ? void 0 : opts.marshaller, r.Item)
                        : marshalling_1.marshaller.unmarshallItem(r.Item)
                    : null;
            })
                .catch(function (e) {
                logger.error(e);
                return Promise.reject(e);
            });
        },
        batchGet: function (keys, opts) {
            var _a;
            var projKeys = ((opts === null || opts === void 0 ? void 0 : opts.keys) || []);
            var projKeysSupplied = projKeys.length > 0;
            var projectionExpressionAttributes = new dynamodb_expressions_1.ExpressionAttributes();
            var projectionExpression = projKeys
                .map(function (k) {
                var exp = projectionExpressionAttributes.addName(new dynamodb_expressions_1.AttributePath(k));
                return exp;
            })
                .join(', ');
            return dynamo
                .batchGetItem({
                RequestItems: (_a = {},
                    _a[tableName] = {
                        Keys: keys.map(function (hkv) {
                            return marshalling_1.marshaller.marshallItem(extractKey(hkv, hashKey, sortKey));
                        }),
                        ConsistentRead: opts === null || opts === void 0 ? void 0 : opts.consistentRead,
                        ProjectionExpression: projKeysSupplied
                            ? projectionExpression
                            : undefined,
                        ExpressionAttributeNames: projKeysSupplied
                            ? projectionExpressionAttributes.names
                            : undefined,
                    },
                    _a),
            })
                .then(function (r) {
                return Object.values(r.Responses)[0].map(marshalling_1.marshaller.unmarshallItem.bind(marshalling_1.marshaller));
            })
                .catch(function (e) {
                logger.error(e);
                return Promise.reject(e);
            });
        },
        transactGet: function (keys) {
            return dynamo
                .transactGetItems({
                TransactItems: keys.map(function (k) { return ({
                    Get: {
                        Key: marshalling_1.marshaller.marshallItem(extractKey(k, hashKey, sortKey)),
                        TableName: tableName,
                    },
                }); }),
            })
                .then(function (r) {
                return r.Responses.map(function (r) {
                    return r.Item ? marshalling_1.marshaller.unmarshallItem(r.Item) : undefined;
                }).filter(function (i) { return i != undefined; });
            })
                .catch(function (e) {
                logger.error(e);
                return Promise.reject(e);
            });
        },
        query: query(dynamo, logger, tableName, hashKey, sortKey, marshalling_1.marshaller),
        scan: scan(dynamo, logger, tableName, hashKey, sortKey, marshalling_1.marshaller),
        put: function (a, opts) {
            var attributes = new dynamodb_expressions_1.ExpressionAttributes();
            var conditionExpression = (opts === null || opts === void 0 ? void 0 : opts.conditionExpression) !== undefined
                ? conditions_1.serializeConditionExpression(opts.conditionExpression, attributes)
                : undefined;
            return dynamo
                .putItem({
                TableName: tableName,
                Item: marshalling_1.marshaller.marshallItem(a),
                ExpressionAttributeNames: Object.keys(attributes.names).length > 0
                    ? attributes.names
                    : undefined,
                ExpressionAttributeValues: Object.keys(attributes.values).length > 0
                    ? attributes.values
                    : undefined,
                ConditionExpression: conditionExpression,
            })
                .then(function (i) {
                return i.Attributes ? marshalling_1.marshaller.unmarshallItem(i.Attributes) : undefined;
            })
                .catch(function (e) {
                logger.error(e);
                return Promise.reject(e);
            });
        },
        set: function (k, v, opts) {
            var request = serializeSetAction(v);
            var attributes = new dynamodb_expressions_1.ExpressionAttributes();
            var expression = request.serialize(attributes);
            var key = marshalling_1.marshaller.marshallItem(extractKey(k, hashKey, sortKey));
            var conditionExpression = (opts === null || opts === void 0 ? void 0 : opts.conditionExpression) ? conditions_1.serializeConditionExpression(opts.conditionExpression, attributes)
                : undefined;
            return dynamo
                .updateItem({
                TableName: tableName,
                Key: key,
                UpdateExpression: expression,
                ExpressionAttributeNames: Object.keys(attributes.names).length > 0
                    ? attributes.names
                    : undefined,
                ExpressionAttributeValues: Object.keys(attributes.values).length > 0
                    ? attributes.values
                    : undefined,
                ReturnValues: (opts === null || opts === void 0 ? void 0 : opts.returnValue) || 'ALL_NEW',
                ConditionExpression: conditionExpression,
            })
                .then(function (i) {
                return i.Attributes ? marshalling_1.marshaller.unmarshallItem(i.Attributes) : undefined;
            })
                .catch(function (e) {
                logger.error(e);
                return Promise.reject(e);
            });
        },
        batchPut: function (a) {
            var _a;
            return dynamo
                .batchWriteItem({
                RequestItems: (_a = {},
                    _a[tableName] = a.map(function (item) { return ({
                        PutRequest: {
                            Item: marshalling_1.marshaller.marshallItem(item),
                        },
                    }); }),
                    _a),
            })
                .then(function () { return ({}); })
                .catch(function (e) {
                logger.error(e);
                return Promise.reject(e);
            });
        },
        batchDelete: function (a) {
            var _a;
            return dynamo
                .batchWriteItem({
                RequestItems: (_a = {},
                    _a[tableName] = a.map(function (item) { return ({
                        DeleteRequest: {
                            Key: marshalling_1.marshaller.marshallItem(extractKey(item, hashKey, sortKey)),
                        },
                    }); }),
                    _a),
            })
                .then(function () { return ({}); })
                .catch(function (e) {
                logger.error(e);
                return Promise.reject(e);
            });
        },
        transactPut: function (a) {
            return exports.Table(tableDefintion, config).transactWrite({ puts: a });
        },
        transactDelete: function (a) {
            return exports.Table(tableDefintion, config).transactWrite({ deletes: a });
        },
        transactWrite: function (args) {
            var deletes = (args.deletes || []).map(function (item) {
                var attributes = new dynamodb_expressions_1.ExpressionAttributes();
                var conditionExpression = item.conditionExpression !== undefined
                    ? conditions_1.serializeConditionExpression(item.conditionExpression, attributes)
                    : undefined;
                return {
                    Delete: {
                        TableName: tableName,
                        Key: marshalling_1.marshaller.marshallItem(extractKey(item.item, hashKey, sortKey)),
                        ConditionExpression: conditionExpression,
                        ExpressionAttributeNames: Object.keys(attributes.names).length > 0
                            ? attributes.names
                            : undefined,
                        ExpressionAttributeValues: Object.keys(attributes.values).length > 0
                            ? attributes.values
                            : undefined,
                    },
                };
            });
            var puts = (args.puts || []).map(function (item) {
                var attributes = new dynamodb_expressions_1.ExpressionAttributes();
                var conditionExpression = item.conditionExpression !== undefined
                    ? conditions_1.serializeConditionExpression(item.conditionExpression, attributes)
                    : undefined;
                return {
                    Put: {
                        TableName: tableName,
                        Item: marshalling_1.marshaller.marshallItem(item.item),
                        ConditionExpression: conditionExpression,
                        ExpressionAttributeNames: Object.keys(attributes.names).length > 0
                            ? attributes.names
                            : undefined,
                        ExpressionAttributeValues: Object.keys(attributes.values).length > 0
                            ? attributes.values
                            : undefined,
                    },
                };
            });
            var updates = (args.updates || []).map(function (u) {
                var request = serializeSetAction(u.updates);
                var attributes = new dynamodb_expressions_1.ExpressionAttributes();
                var expression = request.serialize(attributes);
                var key = marshalling_1.marshaller.marshallItem(extractKey(u.key, hashKey, sortKey));
                var conditionExpression = u.conditionExpression !== undefined
                    ? conditions_1.serializeConditionExpression(u.conditionExpression, attributes)
                    : undefined;
                return {
                    Update: {
                        Key: key,
                        UpdateExpression: expression,
                        ExpressionAttributeNames: Object.keys(attributes.names).length > 0
                            ? attributes.names
                            : undefined,
                        ExpressionAttributeValues: Object.keys(attributes.values).length > 0
                            ? attributes.values
                            : undefined,
                        ConditionExpression: conditionExpression,
                        TableName: tableName,
                    },
                };
            });
            var TransactItems = __spread(deletes, puts, updates);
            return dynamo
                .transactWriteItems({
                TransactItems: TransactItems,
            })
                .then(function () { return ({}); })
                .catch(function (e) {
                logger.error(e);
                return Promise.reject(e);
            });
        },
        delete: function (k, opts) {
            var attributes = new dynamodb_expressions_1.ExpressionAttributes();
            var conditionExpression = (opts === null || opts === void 0 ? void 0 : opts.conditionExpression) !== undefined
                ? conditions_1.serializeConditionExpression(opts.conditionExpression, attributes)
                : undefined;
            return dynamo
                .deleteItem({
                TableName: tableName,
                Key: marshalling_1.marshaller.marshallItem(extractKey(k, hashKey, sortKey)),
                ConditionExpression: conditionExpression,
                ExpressionAttributeNames: Object.keys(attributes.names).length > 0
                    ? attributes.names
                    : undefined,
                ExpressionAttributeValues: Object.keys(attributes.values).length > 0
                    ? attributes.values
                    : undefined,
            })
                .then(function () { return ({}); })
                .catch(function (e) {
                logger.error(e);
                return Promise.reject(e);
            });
        },
        indexes: Object.keys(indexes).reduce(function (p, k) {
            var _a;
            return (__assign(__assign({}, p), (_a = {},
                _a[k] = {
                    query: query(dynamo, logger, tableName, indexes[k].partitionKey, indexes[k].sortKey, marshalling_1.marshaller, indexes[k].name),
                    scan: scan(dynamo, logger, tableName, indexes[k].partitionKey, indexes[k].sortKey, marshalling_1.marshaller, indexes[k].name),
                },
                _a)));
        }, {}),
    };
    return retval;
};
exports.Table = Table;
