"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
/* eslint-disable @typescript-eslint/no-explicit-any */
var client_dynamodb_1 = require("@aws-sdk/client-dynamodb");
var conditions_1 = require("./conditions");
var marshalling_1 = require("./marshalling");
var table_builder_1 = require("./table-builder");
jest.setTimeout(60000); // in milliseconds
describe('Table', function () {
    describe('with simple key', function () {
        var simpleTable = table_builder_1.tableBuilder('SimpleTable')
            .withKey('hash')
            .build({
            client: new client_dynamodb_1.DynamoDB({
                endpoint: 'http://localhost:8000',
                tls: false,
                region: 'local-env',
            }),
        });
        it('Should put and get', function () { return __awaiter(void 0, void 0, void 0, function () {
            var value, result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        value = { hash: '1' };
                        return [4 /*yield*/, simpleTable.put(value)];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, simpleTable.get(value)];
                    case 2:
                        result = _a.sent();
                        expect(result).toEqual(value);
                        return [2 /*return*/];
                }
            });
        }); });
        it('Should put and set and return all new values', function () { return __awaiter(void 0, void 0, void 0, function () {
            var key, setParams, result2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        key = { hash: '1' };
                        return [4 /*yield*/, simpleTable.put(key)];
                    case 1:
                        _a.sent();
                        setParams = { name: 'Johnny', age: 30 };
                        return [4 /*yield*/, simpleTable.set(key, setParams)];
                    case 2:
                        result2 = _a.sent();
                        expect(result2).toEqual(__assign(__assign({}, key), setParams));
                        return [2 /*return*/];
                }
            });
        }); });
        it('Should put and set and return all old values', function () { return __awaiter(void 0, void 0, void 0, function () {
            var key, setParams, result2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        key = { hash: '1' };
                        return [4 /*yield*/, simpleTable.put(key)];
                    case 1:
                        _a.sent();
                        setParams = { name: 'Johnny', age: 30 };
                        return [4 /*yield*/, simpleTable.set(key, setParams, {
                                returnValue: 'ALL_OLD',
                            })];
                    case 2:
                        result2 = _a.sent();
                        expect(result2).toEqual(key);
                        return [2 /*return*/];
                }
            });
        }); });
        it('Should put and set and return updated new values', function () { return __awaiter(void 0, void 0, void 0, function () {
            var key, setParams, result2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        key = { hash: '1' };
                        return [4 /*yield*/, simpleTable.put(key)];
                    case 1:
                        _a.sent();
                        setParams = { name: 'Johnny', age: 30 };
                        return [4 /*yield*/, simpleTable.set(key, setParams, {
                                returnValue: 'UPDATED_NEW',
                            })];
                    case 2:
                        result2 = _a.sent();
                        expect(result2).toEqual(setParams);
                        return [2 /*return*/];
                }
            });
        }); });
        it('Should put and set and return updated old values', function () { return __awaiter(void 0, void 0, void 0, function () {
            var key, setParams, result2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        key = { hash: '1', name: 'Fred' };
                        return [4 /*yield*/, simpleTable.put(key)];
                    case 1:
                        _a.sent();
                        setParams = { name: 'Johnny', age: 30 };
                        return [4 /*yield*/, simpleTable.set(key, setParams, {
                                returnValue: 'UPDATED_OLD',
                            })];
                    case 2:
                        result2 = _a.sent();
                        expect(result2).toEqual({ name: 'Fred' });
                        return [2 /*return*/];
                }
            });
        }); });
        it('Should put and set and return updated new values with a condition expression', function () { return __awaiter(void 0, void 0, void 0, function () {
            var key, setParams, result2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        key = { hash: '1', name: 'Fred' };
                        return [4 /*yield*/, simpleTable.put(key)];
                    case 1:
                        _a.sent();
                        setParams = { name: 'Johnny', age: 30 };
                        return [4 /*yield*/, simpleTable.set(key, setParams, {
                                conditionExpression: { name: { '=': 'Fred' } },
                            })];
                    case 2:
                        result2 = _a.sent();
                        expect(result2).toEqual(__assign(__assign({}, key), setParams));
                        return [2 /*return*/];
                }
            });
        }); });
        it('Should put and not set when condition expression fails', function () { return __awaiter(void 0, void 0, void 0, function () {
            var key, setParams, result2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        key = { hash: '1', name: 'Fred' };
                        return [4 /*yield*/, simpleTable.put(key)];
                    case 1:
                        _a.sent();
                        setParams = { name: 'Johnny', age: 30 };
                        result2 = simpleTable.set(key, setParams, {
                            conditionExpression: { name: { '=': 'John' } },
                        });
                        expect(result2).rejects.toBeTruthy();
                        return [2 /*return*/];
                }
            });
        }); });
        it('Should put and set and return nothing for requesting updated_old values when no old values are updated', function () { return __awaiter(void 0, void 0, void 0, function () {
            var key, setParams, result2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        key = { hash: '1', name: 'Fred' };
                        return [4 /*yield*/, simpleTable.put(key)];
                    case 1:
                        _a.sent();
                        setParams = { age: 30 };
                        return [4 /*yield*/, simpleTable.set(key, setParams, {
                                returnValue: 'UPDATED_OLD',
                            })];
                    case 2:
                        result2 = _a.sent();
                        expect(result2).toEqual(undefined);
                        return [2 /*return*/];
                }
            });
        }); });
        it('Should put and set nested', function () { return __awaiter(void 0, void 0, void 0, function () {
            var key, setParams, result2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        key = { hash: '1', dimensions: { weight: 93 } };
                        return [4 /*yield*/, simpleTable.put(key)];
                    case 1:
                        _a.sent();
                        setParams = {
                            name: 'Johnny',
                            age: 30,
                            dimensions: { height: 183 },
                        };
                        return [4 /*yield*/, simpleTable.set(key, setParams)];
                    case 2:
                        _a.sent();
                        return [4 /*yield*/, simpleTable.get(key)];
                    case 3:
                        result2 = _a.sent();
                        expect(result2).toEqual(__assign(__assign(__assign({}, key), setParams), { dimensions: { weight: 93, height: 183 } }));
                        return [2 /*return*/];
                }
            });
        }); });
        it('Should put and remove nested', function () { return __awaiter(void 0, void 0, void 0, function () {
            var key, setParams, result2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        key = { hash: '1', dimensions: { weight: 93 } };
                        return [4 /*yield*/, simpleTable.put(key)];
                    case 1:
                        _a.sent();
                        setParams = {
                            name: 'Johnny',
                            age: 30,
                            dimensions: { weight: undefined, height: 23 },
                        };
                        return [4 /*yield*/, simpleTable.set(key, setParams)];
                    case 2:
                        _a.sent();
                        return [4 /*yield*/, simpleTable.get(key)];
                    case 3:
                        result2 = _a.sent();
                        expect(result2).toEqual({
                            hash: '1',
                            name: 'Johnny',
                            age: 30,
                            dimensions: { height: 23 },
                        });
                        return [2 /*return*/];
                }
            });
        }); });
        it('Should return null when no object is present', function () { return __awaiter(void 0, void 0, void 0, function () {
            var result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, simpleTable.get({ hash: 'random 123' })];
                    case 1:
                        result = _a.sent();
                        expect(result).toEqual(null);
                        return [2 /*return*/];
                }
            });
        }); });
        it('Should put and get with explicit deserializer', function () { return __awaiter(void 0, void 0, void 0, function () {
            var key, result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        key = { hash: '1', name: 'Fred' };
                        return [4 /*yield*/, simpleTable.put(key)];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, simpleTable.get(key, {
                                marshaller: {
                                    hash: marshalling_1.Marshallers.string,
                                    name: marshalling_1.Marshallers.string,
                                },
                            })];
                    case 2:
                        result = _a.sent();
                        expect(result).toEqual(key);
                        return [2 /*return*/];
                }
            });
        }); });
        it('Should delete', function () { return __awaiter(void 0, void 0, void 0, function () {
            var key, result, deleted;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        key = { hash: '1', age: 30 };
                        return [4 /*yield*/, simpleTable.put(key)];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, simpleTable.get(key)];
                    case 2:
                        result = _a.sent();
                        expect(result).toEqual(key);
                        return [4 /*yield*/, simpleTable.delete(key)];
                    case 3:
                        _a.sent();
                        return [4 /*yield*/, simpleTable.get(key)];
                    case 4:
                        deleted = _a.sent();
                        expect(deleted).toBeNull();
                        return [2 /*return*/];
                }
            });
        }); });
        it('Should delete with condition met', function () { return __awaiter(void 0, void 0, void 0, function () {
            var key, result, deleted;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        key = { hash: '1', age: 30, name: 'Fred' };
                        return [4 /*yield*/, simpleTable.put(key)];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, simpleTable.get(key)];
                    case 2:
                        result = _a.sent();
                        expect(result).toEqual(key);
                        return [4 /*yield*/, simpleTable.delete(key, {
                                conditionExpression: { name: { '=': 'Fred' } },
                            })];
                    case 3:
                        _a.sent();
                        return [4 /*yield*/, simpleTable.get(key)];
                    case 4:
                        deleted = _a.sent();
                        expect(deleted).toBeNull();
                        return [2 /*return*/];
                }
            });
        }); });
        it('Should not delete when condition not met', function () { return __awaiter(void 0, void 0, void 0, function () {
            var key, result, failureResult;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        key = { hash: '1', age: 30, name: 'Joe' };
                        return [4 /*yield*/, simpleTable.put(key)];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, simpleTable.get(key)];
                    case 2:
                        result = _a.sent();
                        expect(result).toEqual(key);
                        failureResult = simpleTable.delete(key, {
                            conditionExpression: { name: { '=': 'Fred' } },
                        });
                        expect(failureResult).rejects.toBeTruthy();
                        return [2 /*return*/];
                }
            });
        }); });
        it('Should not put when condition not met', function () { return __awaiter(void 0, void 0, void 0, function () {
            var key, result, badPutResult, result3;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        key = { hash: '1', age: 30 };
                        return [4 /*yield*/, simpleTable.put(key)];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, simpleTable.get(key)];
                    case 2:
                        result = _a.sent();
                        expect(result).toEqual(key);
                        badPutResult = simpleTable.put({ hash: '1', age: 27 }, { conditionExpression: { age: { '=': 27 } } });
                        expect(badPutResult).rejects.toBeTruthy();
                        return [4 /*yield*/, simpleTable.get(key)];
                    case 3:
                        result3 = _a.sent();
                        expect(result3).toEqual(key);
                        return [2 /*return*/];
                }
            });
        }); });
        it('Should put when condition not met', function () { return __awaiter(void 0, void 0, void 0, function () {
            var key, result, result3;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        key = { hash: '27', age: 30 };
                        return [4 /*yield*/, simpleTable.put(key)];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, simpleTable.get(key)];
                    case 2:
                        result = _a.sent();
                        expect(result).toEqual(key);
                        return [4 /*yield*/, simpleTable.put({ hash: '27', age: 27 }, { conditionExpression: { age: { '=': 30 } } })];
                    case 3:
                        _a.sent();
                        return [4 /*yield*/, simpleTable.get(key)];
                    case 4:
                        result3 = _a.sent();
                        expect(result3).toEqual({ hash: '27', age: 27 });
                        return [2 /*return*/];
                }
            });
        }); });
        it('Should put and get super types of the key', function () { return __awaiter(void 0, void 0, void 0, function () {
            var person, job, personResult, jobResult;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        person = { hash: 'PERSON_1', dob: Date.now(), name: 'Fred' };
                        job = { hash: 'JOB_1', startDate: Date.now(), name: 'Developer' };
                        return [4 /*yield*/, simpleTable.put(person)];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, simpleTable.get({ hash: 'PERSON_1' })];
                    case 2:
                        personResult = _a.sent();
                        expect(personResult).toEqual(person);
                        return [4 /*yield*/, simpleTable.put(job)];
                    case 3:
                        _a.sent();
                        return [4 /*yield*/, simpleTable.get({ hash: 'JOB_1' })];
                    case 4:
                        jobResult = _a.sent();
                        expect(jobResult).toEqual(job);
                        return [2 /*return*/];
                }
            });
        }); });
    });
    describe('with compound key', function () {
        var compoundTable = table_builder_1.tableBuilder('CompoundTable')
            .withKey('hash', 'sort')
            .withGlobalIndex('ix_by_gsihash', 'gsihash', 'gsirange')
            .withLocalIndex('ix_by_lsirange', 'lsirange')
            .build({
            endpoint: 'http://localhost:8000',
            tls: false,
            region: 'local-env',
        });
        it('Should put and get', function () { return __awaiter(void 0, void 0, void 0, function () {
            var key, result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        key = { hash: '1', sort: 1, lsirange: 1 };
                        return [4 /*yield*/, compoundTable.put(key)];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, compoundTable.get(key)];
                    case 2:
                        result = _a.sent();
                        expect(result === null || result === void 0 ? void 0 : result.hash).toEqual(key.hash);
                        expect(result === null || result === void 0 ? void 0 : result.sort).toEqual(key.sort);
                        return [2 /*return*/];
                }
            });
        }); });
        describe('with selected keys', function () {
            var key = {
                hash: '1',
                sort: 1,
                gsihash: 'gsi hash value',
                lsirange: 1,
                complexSubDoc: {
                    id: '321',
                    subSubDoc: {
                        id: '123',
                        name: 'fred',
                    },
                },
            };
            var setup = function () { return __awaiter(void 0, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, compoundTable.put(key)];
                        case 1:
                            _a.sent();
                            return [2 /*return*/, compoundTable.get(key, {
                                    keys: ['gsihash', 'sort', 'complexSubDoc.subSubDoc.id'],
                                })];
                    }
                });
            }); };
            it('Should get selected keys', function () { return __awaiter(void 0, void 0, void 0, function () {
                var result;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, setup()];
                        case 1:
                            result = _a.sent();
                            expect(result === null || result === void 0 ? void 0 : result.gsihash).toEqual(key.gsihash);
                            expect(result === null || result === void 0 ? void 0 : result.sort).toEqual(key.sort);
                            expect(result === null || result === void 0 ? void 0 : result.complexSubDoc.subSubDoc.id).toEqual('123');
                            expect((result === null || result === void 0 ? void 0 : result.complexSubDoc.subSubDoc).name).toBeUndefined();
                            expect((result === null || result === void 0 ? void 0 : result.complexSubDoc).id).toBeUndefined();
                            return [2 /*return*/];
                    }
                });
            }); });
            it('Should not fetch non selected keys', function () { return __awaiter(void 0, void 0, void 0, function () {
                var result;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, setup()];
                        case 1:
                            result = _a.sent();
                            expect(result === null || result === void 0 ? void 0 : result.gsihash).toEqual(key.gsihash);
                            expect(result.hash).toBeUndefined();
                            return [2 /*return*/];
                    }
                });
            }); });
        });
        it('Should put and batch get', function () { return __awaiter(void 0, void 0, void 0, function () {
            var key1, key2, results;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        key1 = { hash: '1', sort: 1, lsirange: 1 };
                        key2 = { hash: '2', sort: 1, lsirange: 2 };
                        return [4 /*yield*/, compoundTable.batchPut([key1, key2])];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, compoundTable.batchGet([key1, key2])];
                    case 2:
                        results = _a.sent();
                        expect(results).toContainEqual(key1);
                        expect(results).toContainEqual(key2);
                        return [2 /*return*/];
                }
            });
        }); });
        it('Should put and batch get selected keys', function () { return __awaiter(void 0, void 0, void 0, function () {
            var key1, key2, results;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        key1 = { hash: '1', sort: 1, lsirange: 1 };
                        key2 = { hash: '2', sort: 1, lsirange: 2 };
                        return [4 /*yield*/, compoundTable.batchPut([key1, key2])];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, compoundTable.batchGet([key1, key2], {
                                keys: ['lsirange'],
                                consistentRead: true,
                            })];
                    case 2:
                        results = _a.sent();
                        expect(results).toContainEqual({ lsirange: 1 });
                        expect(results).toContainEqual({ lsirange: 2 });
                        return [2 /*return*/];
                }
            });
        }); });
        it('Should transact put and get', function () { return __awaiter(void 0, void 0, void 0, function () {
            var key1, key2, results;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        key1 = { hash: '1', sort: 1, lsirange: 1 };
                        key2 = { hash: '2', sort: 1, lsirange: 2 };
                        return [4 /*yield*/, compoundTable.transactPut([{ item: key1 }, { item: key2 }])];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, compoundTable.transactGet([key1, key2])];
                    case 2:
                        results = _a.sent();
                        expect(results).toContainEqual(key1);
                        expect(results).toContainEqual(key2);
                        return [2 /*return*/];
                }
            });
        }); });
        it('Should put and batch delete', function () { return __awaiter(void 0, void 0, void 0, function () {
            var key1, key2, results;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        key1 = { hash: '1', sort: 1, lsirange: 1 };
                        key2 = { hash: '2', sort: 1, lsirange: 2 };
                        return [4 /*yield*/, compoundTable.batchPut([key1, key2])];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, compoundTable.batchDelete([key1, key2])];
                    case 2:
                        _a.sent();
                        return [4 /*yield*/, compoundTable.batchGet([key1, key2])];
                    case 3:
                        results = _a.sent();
                        expect(results).toEqual([]);
                        return [2 /*return*/];
                }
            });
        }); });
        it('Should transact put and delete', function () { return __awaiter(void 0, void 0, void 0, function () {
            var key1, key2, results;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        key1 = { hash: '1', sort: 1, lsirange: 1 };
                        key2 = { hash: '2', sort: 1, lsirange: 2 };
                        return [4 /*yield*/, compoundTable.transactPut([{ item: key1 }, { item: key2 }])];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, compoundTable.transactDelete([{ item: key1 }, { item: key2 }])];
                    case 2:
                        _a.sent();
                        return [4 /*yield*/, compoundTable.batchGet([key1, key2])];
                    case 3:
                        results = _a.sent();
                        expect(results).toEqual([]);
                        return [2 /*return*/];
                }
            });
        }); });
        it.skip('Should transactionally put and get', function () { return __awaiter(void 0, void 0, void 0, function () {
            var key1, key2, results;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        key1 = { hash: '1', sort: 1, lsirange: 1 };
                        key2 = { hash: '2', sort: 1, lsirange: 2 };
                        return [4 /*yield*/, compoundTable.transactPut([{ item: key1 }, { item: key2 }])];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, compoundTable.transactGet([key1, key2])];
                    case 2:
                        results = _a.sent();
                        expect(results).toContainEqual(key1);
                        expect(results).toContainEqual(key2);
                        return [2 /*return*/];
                }
            });
        }); });
        it('Should return subset of input array for batch get where only a subset exist', function () { return __awaiter(void 0, void 0, void 0, function () {
            var key1, key2, result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        key1 = { hash: '1', sort: 1, lsirange: 1 };
                        key2 = { hash: '19', sort: 1 };
                        return [4 /*yield*/, compoundTable.put(key1)];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, compoundTable.batchGet([key1, key2])];
                    case 2:
                        result = _a.sent();
                        expect(result).toEqual([{ hash: '1', sort: 1, lsirange: 1 }]);
                        return [2 /*return*/];
                }
            });
        }); });
        it('Should return subset of input array for transactGet where only a subset exist', function () { return __awaiter(void 0, void 0, void 0, function () {
            var key1, key2, result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        key1 = { hash: '1', sort: 1, lsirange: 1 };
                        key2 = { hash: '19', sort: 1 };
                        return [4 /*yield*/, compoundTable.put(key1)];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, compoundTable.batchGet([key1, key2], {
                                keys: ['lsirange'],
                            })];
                    case 2:
                        result = _a.sent();
                        expect(result).toEqual([{ lsirange: 1 }]);
                        return [2 /*return*/];
                }
            });
        }); });
        it('Should return empty array if batch get has no records', function () { return __awaiter(void 0, void 0, void 0, function () {
            var key1, key2, result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        key1 = { hash: '18', sort: 1 };
                        key2 = { hash: '19', sort: 1 };
                        return [4 /*yield*/, compoundTable.batchGet([key1, key2])];
                    case 1:
                        result = _a.sent();
                        expect(result).toEqual([]);
                        return [2 /*return*/];
                }
            });
        }); });
        it('Should put and query', function () { return __awaiter(void 0, void 0, void 0, function () {
            var testObjects, result, result2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        testObjects = Array.from(Array(20).keys()).map(function (i) { return ({
                            hash: '1',
                            sort: i,
                        }); });
                        return [4 /*yield*/, Promise.all(testObjects.map(function (o) { return compoundTable.put(o); }))];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, compoundTable.query('1', { pageSize: 10 })];
                    case 2:
                        result = _a.sent();
                        expect(result.records).toEqual(testObjects.slice(0, 10));
                        return [4 /*yield*/, compoundTable.query('1', {
                                pageSize: 10,
                                fromSortKey: result.lastSortKey,
                            })];
                    case 3:
                        result2 = _a.sent();
                        expect(result2.records).toEqual(testObjects.slice(10));
                        return [2 /*return*/];
                }
            });
        }); });
        it('Should put and query with nextSortKey object', function () { return __awaiter(void 0, void 0, void 0, function () {
            var testObjects, result, result2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        testObjects = Array.from(Array(20).keys()).map(function (i) { return ({
                            hash: '1',
                            sort: i,
                        }); });
                        return [4 /*yield*/, Promise.all(testObjects.map(function (o) { return compoundTable.put(o); }))];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, compoundTable.query('1', { pageSize: 10 })];
                    case 2:
                        result = _a.sent();
                        expect(result.records).toEqual(testObjects.slice(0, 10));
                        return [4 /*yield*/, compoundTable.query('1', {
                                pageSize: 10,
                                startKey: result.nextStartKey,
                            })];
                    case 3:
                        result2 = _a.sent();
                        expect(result2.records).toEqual(testObjects.slice(10));
                        return [2 /*return*/];
                }
            });
        }); });
        it('Should put and query with sort key expression', function () { return __awaiter(void 0, void 0, void 0, function () {
            var testObjects, result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        testObjects = Array.from(Array(20).keys()).map(function (i) { return ({
                            hash: '1',
                            sort: i,
                        }); });
                        return [4 /*yield*/, Promise.all(testObjects.map(function (o) { return compoundTable.put(o); }))];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, compoundTable.query('1', {
                                pageSize: 10,
                                sortKeyExpression: conditions_1.between(1, 5),
                            })];
                    case 2:
                        result = _a.sent();
                        expect(result.records).toEqual(testObjects.filter(function (r) { return 1 <= r.sort && r.sort <= 5; }));
                        return [2 /*return*/];
                }
            });
        }); });
        it('Should put and query with a filter expression', function () { return __awaiter(void 0, void 0, void 0, function () {
            var testObjects, result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        testObjects = Array.from(Array(20).keys()).map(function (i) { return ({
                            hash: '1234',
                            sort: i,
                            lsirange: i,
                        }); });
                        return [4 /*yield*/, compoundTable.transactPut(testObjects.map(function (item) { return ({ item: item }); }))];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, compoundTable.query('1234', {
                                pageSize: 10,
                                filterExpression: { lsirange: { '=': 5 } },
                            })];
                    case 2:
                        result = _a.sent();
                        expect(result.records.length).toBe(1);
                        expect(result.records[0]).toEqual({
                            hash: '1234',
                            sort: 5,
                            lsirange: 5,
                        });
                        return [2 /*return*/];
                }
            });
        }); });
        it('Should put and query with a complex filter expression', function () { return __awaiter(void 0, void 0, void 0, function () {
            var testObjects, result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        testObjects = Array.from(Array(20).keys()).map(function (i) { return ({
                            hash: '1234',
                            sort: i,
                            lsirange: i,
                            name: i % 2 === 0 ? 'Fred' : 'Bob',
                        }); });
                        return [4 /*yield*/, compoundTable.transactPut(testObjects.map(function (item) { return ({ item: item }); }))];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, compoundTable.query('1234', {
                                filterExpression: conditions_1.AND(conditions_1.OR({
                                    lsirange: { '=': 5 },
                                    name: conditions_1.beginsWith('Fre'),
                                }, conditions_1.NOT({ lsirange: conditions_1.between(7, 13) })), { name: conditions_1.isIn(['Fred', 'John', 'Mike']) }),
                            })];
                    case 2:
                        result = _a.sent();
                        expect(result.records.length).toBe(11);
                        expect(result.records.every(function (r) {
                            return r.lsirange === 5 ||
                                r.name === 'Fred' ||
                                !(7 > r.lsirange && r.lsirange > 13);
                        }));
                        return [2 /*return*/];
                }
            });
        }); });
        it('Should put and query using greater than', function () { return __awaiter(void 0, void 0, void 0, function () {
            var testObjects, result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        testObjects = Array.from(Array(20).keys()).map(function (i) { return ({
                            hash: '111',
                            sort: i,
                            documentVersionId: '1',
                        }); });
                        return [4 /*yield*/, Promise.all(testObjects.map(function (o) {
                                return compoundTable.put(o, {
                                    conditionExpression: conditions_1.OR({
                                        documentVersionId: conditions_1.attributeNotExists(),
                                    }, {
                                        documentVersionId: { '=': o.documentVersionId },
                                    }),
                                });
                            }))];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, compoundTable.query('111', {
                                pageSize: 10,
                                sortKeyExpression: { '>': 15 },
                            })];
                    case 2:
                        result = _a.sent();
                        expect(result.records).toEqual(testObjects.slice(16));
                        return [2 /*return*/];
                }
            });
        }); });
        it('Should put and query a GSI', function () { return __awaiter(void 0, void 0, void 0, function () {
            var testObjects, result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        testObjects = Array.from(Array(20).keys()).map(function (i) { return ({
                            hash: '1',
                            sort: i,
                            gsihash: 'hash',
                            gsirange: "" + (100 - i),
                            lsirange: 1,
                        }); });
                        return [4 /*yield*/, compoundTable.batchPut(testObjects)];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, compoundTable.indexes.ix_by_gsihash.query('hash')];
                    case 2:
                        result = _a.sent();
                        expect(result.records.length).toEqual(testObjects.length);
                        return [2 /*return*/];
                }
            });
        }); });
        it('Should put and query a GSI and filter condition', function () { return __awaiter(void 0, void 0, void 0, function () {
            var testObjects, result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        testObjects = Array.from(Array(20).keys()).map(function (i) { return ({
                            hash: '1',
                            sort: i,
                            gsihash: 'hash',
                            gsirange: "" + (100 - i),
                            lsirange: 1,
                        }); });
                        return [4 /*yield*/, compoundTable.batchPut(testObjects)];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, compoundTable.indexes.ix_by_gsihash.query('hash', {
                                filterExpression: { sort: { '=': 9 }, lsirange: { '=': 1 } },
                            })];
                    case 2:
                        result = _a.sent();
                        expect(result.records.length).toEqual(1);
                        expect(result.records[0]).toEqual({
                            hash: '1',
                            sort: 9,
                            gsihash: 'hash',
                            gsirange: "91",
                            lsirange: 1,
                        });
                        return [2 /*return*/];
                }
            });
        }); });
        it('Should put and query a LSI', function () { return __awaiter(void 0, void 0, void 0, function () {
            var testObjects, result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        testObjects = Array.from(Array(20).keys()).map(function (i) { return ({
                            hash: '1',
                            sort: i,
                            lsirange: 20 - i,
                        }); });
                        return [4 /*yield*/, compoundTable.batchPut(testObjects)];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, compoundTable.indexes.ix_by_lsirange.query('1', {
                                sortKeyExpression: { '>': 5 },
                            })];
                    case 2:
                        result = _a.sent();
                        expect(__spread(result.records).sort(function (a, b) { return a.lsirange - b.lsirange; })).toEqual(__spread(testObjects.filter(function (a) { return a.lsirange > 5; })).sort(function (a, b) { return a.lsirange - b.lsirange; }));
                        return [2 /*return*/];
                }
            });
        }); });
        it('should transact write', function () { return __awaiter(void 0, void 0, void 0, function () {
            var testObjects, updateResults;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        testObjects = Array.from(Array(5).keys()).map(function (i) { return ({
                            hash: 'Transact Write Test',
                            sort: i,
                            lsirange: 20 - i,
                            name: "Fred " + i,
                        }); });
                        return [4 /*yield*/, compoundTable.batchPut(testObjects)];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, compoundTable.transactWrite({
                                deletes: [
                                    {
                                        item: {
                                            hash: 'Transact Write Test',
                                            sort: 1,
                                        },
                                    },
                                    {
                                        item: {
                                            hash: 'Transact Write Test',
                                            sort: 2,
                                        },
                                    },
                                ],
                                puts: [
                                    {
                                        item: {
                                            hash: 'Transact Write Test',
                                            sort: 50,
                                            lsirange: 80,
                                            name: 'fdsdf',
                                        },
                                    },
                                ],
                                updates: [
                                    {
                                        key: {
                                            hash: 'Transact Write Test',
                                            sort: 4,
                                        },
                                        updates: {
                                            lsirange: 500,
                                        },
                                    },
                                ],
                            })];
                    case 2:
                        _a.sent();
                        return [4 /*yield*/, compoundTable.query('Transact Write Test')];
                    case 3:
                        updateResults = _a.sent();
                        expect(updateResults.records).toEqual([
                            { hash: 'Transact Write Test', lsirange: 20, name: 'Fred 0', sort: 0 },
                            { hash: 'Transact Write Test', lsirange: 17, name: 'Fred 3', sort: 3 },
                            { hash: 'Transact Write Test', lsirange: 500, name: 'Fred 4', sort: 4 },
                            { hash: 'Transact Write Test', lsirange: 80, name: 'fdsdf', sort: 50 },
                        ]);
                        return [2 /*return*/];
                }
            });
        }); });
        it('Should delete', function () { return __awaiter(void 0, void 0, void 0, function () {
            var key, result, deleted;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        key = { hash: '222', sort: 1, lsirange: 1 };
                        return [4 /*yield*/, compoundTable.put(key)];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, compoundTable.get(key)];
                    case 2:
                        result = _a.sent();
                        expect(result).toEqual(key);
                        return [4 /*yield*/, compoundTable.delete(key)];
                    case 3:
                        _a.sent();
                        return [4 /*yield*/, compoundTable.get(key)];
                    case 4:
                        deleted = _a.sent();
                        expect(deleted).toBeNull();
                        return [2 /*return*/];
                }
            });
        }); });
        it('Should scan', function () { return __awaiter(void 0, void 0, void 0, function () {
            var key, result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        key = { hash: 'scan test', sort: 1, lsirange: 1 };
                        return [4 /*yield*/, compoundTable.put(key)];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, compoundTable.scan()];
                    case 2:
                        result = _a.sent();
                        expect(result.records).toContainEqual(key);
                        return [2 /*return*/];
                }
            });
        }); });
        it('Should scan with paging', function () { return __awaiter(void 0, void 0, void 0, function () {
            var records, result, result2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        records = Array.from(Array(20).keys()).map(function (i) { return ({
                            hash: 'scan test paging',
                            sort: i,
                            lsirange: i,
                        }); });
                        return [4 /*yield*/, compoundTable.transactPut(records.map(function (item) { return ({ item: item }); }))];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, compoundTable.scan({
                                pageSize: 5,
                            })];
                    case 2:
                        result = _a.sent();
                        expect(result.records.length).toEqual(5);
                        expect(result.lastSortKey).toBeTruthy();
                        expect(result.lastHashKey).toBeTruthy();
                        return [4 /*yield*/, compoundTable.scan({
                                fromHashKey: result.lastHashKey,
                                fromSortKey: result.lastSortKey,
                            })];
                    case 3:
                        result2 = _a.sent();
                        expect(result2.records.length).toBeGreaterThanOrEqual(15);
                        expect(result2.records).toEqual(
                        // eslint-disable-next-line functional/prefer-readonly-type
                        expect.not.arrayContaining(result.records));
                        return [2 /*return*/];
                }
            });
        }); });
        it('Should scan with filtering', function () { return __awaiter(void 0, void 0, void 0, function () {
            var records, result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        records = Array.from(Array(20).keys()).map(function (i) { return ({
                            hash: 'scan test paging',
                            sort: i,
                            lsirange: i,
                        }); });
                        return [4 /*yield*/, compoundTable.transactPut(records.map(function (item) { return ({ item: item }); }))];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, compoundTable.scan({
                                filterExpression: { hash: { '=': 'scan test paging' } },
                            })];
                    case 2:
                        result = _a.sent();
                        expect(result.records.length).toEqual(20);
                        return [2 /*return*/];
                }
            });
        }); });
    });
});
